/*
Copyright 1990-2001 Sun Microsystems, Inc. All Rights Reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions: The above copyright notice and this
permission notice shall be included in all copies or substantial
portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE OPEN GROUP OR SUN MICROSYSTEMS, INC. BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.


Except as contained in this notice, the names of The Open Group and/or
Sun Microsystems, Inc. shall not be used in advertising or otherwise to
promote the sale, use or other dealings in this Software without prior
written authorization from The Open Group and/or Sun Microsystems,
Inc., as applicable.


X Window System is a trademark of The Open Group

OSF/1, OSF/Motif and Motif are registered trademarks, and OSF, the OSF
logo, LBX, X Window System, and Xinerama are trademarks of the Open
Group. All other trademarks and registered trademarks mentioned herein
are the property of their respective owners. No right, title or
interest in or to any trademark, service mark, logo or trade name of
Sun Microsystems, Inc. or its licensors is granted.

*/


package sun.awt.im.iiimp;

import java.awt.*;
import java.text.*;
import com.sun.iiim.*;

class PreeditPane extends Canvas {
    private String composedString;
    private int caret;
    private final static int TEXT_ORIGIN_X = 5;
    private final static int TEXT_ORIGIN_Y = 15;
    
    private int width, height;
    FontMetrics metrics;        
    
    /**
     * Default, no arg constructor
     */
    public PreeditPane() {
    }
    
    public void paint(Graphics g) {
        super.paint(g);
        
        if(composedString.length() > 0) {
            g.setColor(getForeground());
            g.drawString(composedString, TEXT_ORIGIN_X, TEXT_ORIGIN_Y);
        }
        Rectangle rect = getCaretRectangle();
        
        g.fillRect(rect.x, rect.y, 1, rect.height);
    }

    private Rectangle getCaretRectangle() {
        int width = 0;
        
        if (caret > 0) {
            char chars[] = new char[caret];
            // can't call getChars() if composedText.length() == 0
            composedString.getChars(0, caret, chars, 0);
            width = metrics.charsWidth(chars, 0, caret);
        }
        return new Rectangle(TEXT_ORIGIN_X + width,
                             TEXT_ORIGIN_Y - metrics.getAscent(),
                             0, metrics.getAscent() + metrics.getDescent());    
    }
    
    void handleEvent(IIIMPreeditEvent e) {
        if(metrics == null) metrics = getGraphics().getFontMetrics();

        composedString = new String();
        AttributedCharacterIterator str = e.getIterator();
        for(char c = str.first(); c != CharacterIterator.DONE; 
            c = str.next()) {
            composedString += c;
        }

        width = metrics.stringWidth(composedString);
        height = metrics.getHeight();
        caret = e.getCaret();
        
        repaint();
    }
    
    int width() {
        return width;
    }
    
    int height() {
        return height;
    }
}
